<?php

declare(strict_types=1);

namespace Drupal\message_recipient;

/**
 * Interface for recipients collector manager.
 */
interface CollectorExtenderManagerInterface {

  /**
   * Get the definition of a recipients' collector by plugin id.
   *
   * @return array
   *   The definition of the recipients' collector.
   */
  public function getDefinitionById(string $id): array;

  /**
   * Get definitions' list of available recipients collectors grouped by type.
   *
   * @return string[]
   *   An associative array containing the list of available recipients
   *   collectors' labels keyed by their ids.
   */
  public function getDefinitionsListOptionsGroupedByCategory(): array;

}
