<?php

declare(strict_types=1);

namespace Drupal\message_recipient;

use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Entity\Query\QueryInterface;
use Drupal\message\MessageInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Base class for user recipients collector instances.
 */
abstract class UserRecipientsCollectorBase extends RecipientsCollectorBase implements UserRecipientsCollectorInterface {

  use CollectorExtenderQueryTrait;

  /**
   * The entity type manager.
   *
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   */
  protected EntityTypeManagerInterface $entityTypeManager;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition): self {
    $instance = parent::create($container, $configuration, $plugin_id, $plugin_definition);
    $instance->entityTypeManager = $container->get('entity_type.manager');
    return $instance;
  }

  /**
   * {@inheritdoc}
   */
  public function query(MessageInterface $message): QueryInterface {
    $query = $this->entityTypeManager->getStorage('user')->getQuery();
    $query->accessCheck(FALSE);
    $this->alterQuery($query, $message);
    return $query;
  }

}
